<template>
  <div class="barra">
    <icono-de-estado :cantidad="getCantidad('compromiso')" tipo="compromiso" />
    <icono-de-estado :cantidad="getCantidad('a_favor')" tipo="a_favor" />
    <icono-de-estado :cantidad="getCantidad('en_contra')" tipo="en_contra" />
    <icono-de-estado :cantidad="getCantidad('bloqueo')" tipo="bloqueo" />
    <icono-de-estado
      :cantidad="getCantidad('indiferente')"
      tipo="indiferente"
    />
  </div>
</template>

<script>
import IconoDeEstado from '@/components/IconoDeEstado.vue'

export default {
  name: 'BarraDeEstado',
  props: ['posiciones'],
  components: {
    IconoDeEstado,
  },
  methods: {
    getCantidad(tipoDeEstado) {
      return this.ultimasPosiciones.filter(
        posicion => posicion.estado === tipoDeEstado,
      ).length
    },
  },
  computed: {
    ultimasPosiciones() {
      let ultimasPosiciones = []
      for (const posicion of [...this.posiciones].reverse()) {
        if (
          !ultimasPosiciones.find(
            ({ pirata: { id } }) => id === posicion.pirata.id,
          )
        ) {
          ultimasPosiciones.push(posicion)
        }
      }
      return ultimasPosiciones
    },
    estados() {
      return this.ultimasPosiciones.reduce(
        (total, { estado }) => ({ ...total, [estado]: total[estado] + 1 || 1 }),
        {},
      )
    },
  },
}
</script>

<style lang="sass" scoped>
.barra
  width: 100%
  //background: #AAA;
  display: flex
  //flex-wrap: wrap
  align-items: stretch
  justify-content: space-around
  padding: 0.5em
  //border: 5px solid var(--accent)
  //border-radius: 12px
</style>
